import java.io.*;
import java.util.Random;
//import java.lang.String;

public final class Xmlgen {

	public static String fileName = new String();
	public static int N = 0;
	public static int model_num = 0;
	public static int DIM = 0;
	public static int fifoSize = 0;

	public static String str = new String();
	public static String str2 = "xyz";
	
	public static final void main(String[] Args)
	{       
		 if (Args.length > 0) {
                        try {
				model_num = Integer.parseInt(Args[0]);
				N = Integer.parseInt(Args[1]);
				DIM = Integer.parseInt(Args[2]);
			} catch (NumberFormatException e) {
                                System.err.println("Argument must be an integer");
                                System.exit(1);
                        }
                }

		fileName = "model"+model_num+".xml";
		fifoSize = 8*10*(DIM/N)*(DIM/N);	//8: size of double, 10: max no. of sub-matrices 

		String processName = new String();
		String portName = new String();
		String fifoName = new String();
		String connectionName = new String();

		int i, j = 0, k, l, x;
		try 
		{
			BufferedWriter out = new BufferedWriter(new FileWriter(fileName, true));
			XMLInit(out);	//Initialize the XML
	
			//Generator Process
			out.write("<process name=\"generator\">\n");
			out.write("\t<iterator variable =\"i\" range=\"N\">\n");
			out.write("\t\t<iterator variable =\"j\" range=\"N\">\n");
			out.write("\t\t\t<port type=\"output\" name=\"OUT\">\n");
			out.write("\t\t\t\t<append function=\"i\"/>\n");
			out.write("\t\t\t\t<append function=\"j\"/>\n");
			out.write("\t\t\t</port>\n");
			out.write("\t\t</iterator>\n");
			out.write("\t</iterator>\n");
			out.write("\t<source type=\"c\" location=\"generator.c\"/>\n");
			out.write("</process>\n\n");
			
			//Consumer Process
			out.write("<process name=\"consumer\">\n");
			out.write("\t<iterator variable =\"i\" range=\"N\">\n");
			out.write("\t\t<iterator variable =\"j\" range=\"N\">\n");
             		out.write("\t\t\t<port type=\"input\" name=\"IN\">\n");
			out.write("\t\t\t\t<append function=\"i\"/>\n");
			out.write("\t\t\t\t<append function=\"j\"/>\n");
			out.write("\t\t\t</port>\n");
			out.write("\t\t</iterator>\n");
			out.write("\t</iterator>\n");
			out.write("\t<source type=\"c\" location=\"consumer.c\"/>\n");
			out.write("</process>\n\n");
    
			//Decomposition Processes
			for(i = 0; i < N; i++)
			{
				processName = processNameGen(i, i);
				out.write("<process name = " + "\""+processName+"\"" + ">\n");
				out.write("\t<port type = \"input\" name = \"port_generator\"/>\n");
				for(k = 0; k < i; k++)
                    		{
                     		    portName = portNameGen(i, k, 1);
                      		   out.write("\t<port type = \"input\" name = \""+portName+"\"/>\n");
                 		}
				for(j = 0; j < N-i-1; j++)
				{
					portName = portNameGen(j+i+1, i, 0);
					out.write("\t<port type = \"output\" name = \""+portName+"\"/>\n");
				}
				out.write("\t<port type = \"output\" name = \"port_consumer\"/>\n");
				out.write("\t<source type=\"c\" location=\""+processName+".c\"/>\n");
				out.write("</process>\n\n");
			}
			for(i = 0; i < N ; i++)
			{
				for(j = i+1; j < N; j++)
				{
					processGen(out, j, i);
				}
			}
			//Generating FIFOs
			
			//Generator & Consumer Fifo
			gcFifos(out);
			
			//Process Fifo
			for(i = 0; i < N; i++)
			{
				for(j = i+1; j < N; j++)
				{
					fifoName = fifoNameGen(i, i, j, i);
					fifoGen(out, fifoName);
					for(x = i+1; x < j+1; x++)
					{
						fifoName = fifoNameGen(j, i, j, x);
						fifoGen(out, fifoName);
					}
					for(x = j+1; x < N; x++)
					{
						fifoName = fifoNameGen(j, i, x, j);
						fifoGen(out, fifoName);
					}
				}
			}

			//Generating Connections
			//generator & consumer connections
			gcConnections(out);
			
			//process connections
			for(i = 0; i < N; i++)
			{
				for(j = i+1; j < N; j++)
				{
					connectionGen(out, i, i, j, i);
					for(x = i+1; x < j+1; x++)
						connectionGen(out, j, i, j, x);
					for(x = j+1; x < N; x++)
						connectionGen(out, j, i, x, j);						
				}
			}
			out.write("\n</processnetwork>");			
			out.close();
		}     	
		catch (IOException e) {}
	}
	//Functions
	public static void processGen(BufferedWriter outp, int i, int j)
	{
		String processName = new String();
		String portName = new String();
		int x;
		try 
		{
			processName = processNameGen(i, j);
			outp.write("<process name = " + "\""+processName+"\"" + ">\n");
			outp.write("\t<port type = \"input\" name = \"port_generator\"/>\n");
			portName = portNameGen(j, j, 1);
			outp.write("\t<port type = \"input\" name = \""+portName+"\"/>\n");
			for(x = 0; x < j; x++)
			{
				portName = portNameGen(j, x, 1);
				outp.write("\t<port type = \"input\" name = \""+portName+"\"/>\n");
				portName = portNameGen(i, x, 1);
				outp.write("\t<port type = \"input\" name = \""+portName+"\"/>\n");
			}
			for(x = j+1; x < i+1; x++)
			{
				portName = portNameGen(i, x, 0);
				outp.write("\t<port type = \"output\" name = \""+portName+"\"/>\n");
			}
			for(x = i+1; x < N; x++)
			{
				portName = portNameGen(x, i, 0);
				outp.write("\t<port type = \"output\" name = \""+portName+"\"/>\n");
			}
			outp.write("\t<port type = \"output\" name = \"port_consumer\"/>\n");
			outp.write("\t<source type=\"c\" location=\""+processName+".c\"/>\n");
			outp.write("</process>\n\n");
		}
		catch (IOException e) {}
	}
	public static void connectionGen(BufferedWriter outc, int i, int j, int k, int l)
	{
		String cn = new String();
		String processName = new String();
		String portName = new String();
		String fifoName = new String();
		try {
			cn = connectionNameGen(i, j, k, l, 0);
			processName = processNameGen(i, j);
			portName = portNameGen(k, l, 0);
			fifoName = fifoNameGen(i, j, k, l);
		
			outc.write("\n<connection name=\""+cn+"\">\n");
			outc.write("\t<origin name=\""+processName+"\">\n");
			outc.write("\t\t<port name=\""+portName+"\"/>\n");
			outc.write("\t</origin>\n");
			outc.write("\t<target name=\""+fifoName+"\">\n");
			outc.write("\t\t<port name=\"0\"/>\n");
			outc.write("\t</target>\n");
			outc.write("</connection>\n");
			
			cn = connectionNameGen(i, j, k, l, 1);
			processName = processNameGen(k, l);
			portName = portNameGen(i, j, 1);
			fifoName = fifoNameGen(i, j, k, l);
			
			outc.write("<connection name=\""+cn+"\">\n");
	                outc.write("\t<origin name=\""+fifoName+"\">\n");
  	        	outc.write("\t\t<port name=\"1\"/>\n");
       	 		outc.write("\t</origin>\n");
			outc.write("\t<target name=\""+processName+"\">\n");
	       	        outc.write("\t\t<port name=\""+portName+"\"/>\n");
       		        outc.write("\t</target>\n");
       		        outc.write("</connection>\n");
		}
		catch (IOException e) {}
	}
	
	public static void gcConnections(BufferedWriter outGC)
	{
		int i, j;
		try {
	
			for(i = 0; i < N; i++)
               		{
                		for(j = i; j < N; j++)
                       		{
                        		//g-f
                               		 outGC.write("<connection name=\"g-f_gen_"+j+"_"+i+"\">\n");
                               		 outGC.write("\t<origin name=\"generator\">\n");
                               		 outGC.write("\t\t<port name=\"OUT_"+j+"_"+i+"\"/>\n");
                              	 	 outGC.write("\t</origin>\n");
                               		 outGC.write("\t<target name=\"FIFO_GEN_"+j+"_"+i+"\">\n");
                               		 outGC.write("\t\t<port name=\"0\"/>\n");
                               		 outGC.write("\t</target>\n");
                              	 	 outGC.write("</connection>\n\n");
                              	 	 //f-p
                  	        	 outGC.write("<connection name=\"f-p_gen_"+j+"_"+i+"\">\n");
                        	       	 outGC.write("\t<origin name=\"FIFO_GEN_"+j+"_"+i+"\">\n");
                        	       	 outGC.write("\t\t<port name=\"1\"/>\n");
                         	      	 outGC.write("\t</origin>\n");
                               		 outGC.write("\t<target name=\"p_"+j+"_"+i+"\">\n");
                               		 outGC.write("\t\t<port name=\"port_generator\"/>\n");
                               		 outGC.write("\t</target>\n");
                               		 outGC.write("</connection>\n\n");

                                        //p-f
	                	         outGC.write("<connection name=\"p-f_"+j+"_"+i+"_con\">\n");
       		                         outGC.write("\t<origin name=\"p_"+j+"_"+i+"\">\n");
       		                         outGC.write("\t\t<port name=\"port_consumer\"/>\n");
       	        	                 outGC.write("\t</origin>\n");
       		                         outGC.write("\t<target name=\"FIFO_"+j+"_"+i+"_CON\">\n");
       		                         outGC.write("\t\t<port name=\"0\"/>\n");
       		                         outGC.write("\t</target>\n");
       		                         outGC.write("</connection>\n\n");
                              		 //f-c
                      	 	         outGC.write("<connection name=\"f-c_"+j+"_"+i+"_con\">\n");
                       	 		 outGC.write("\t<origin name=\"FIFO_"+j+"_"+i+"_CON\">\n");
                       	 	         outGC.write("\t\t<port name=\"1\"/>\n");
                        	         outGC.write("\t</origin>\n");
                       		       	 outGC.write("\t<target name=\"consumer\">\n");
                        	       	 outGC.write("\t\t<port name=\"IN_"+j+"_"+i+"\"/>\n");
                        	         outGC.write("\t</target>\n");
                        	       	 outGC.write("</connection>\n\n");
				}
			}
		} catch (IOException e) {}
	}
	
	public static void gcFifos(BufferedWriter outGC)
	{
		int i, j;
		try {
			for(i = 0; i < N; i++)
                        {
                                for(j = i; j < N; j++)
                                {
                                        outGC.write("<sw_channel type=\"fifo\" size=\""+fifoSize+"\" name=\"FIFO_GEN_"+j+"_"+i+"\">\n");
                                        outGC.write("\t<port type=\"input\" name=\"0\"/>\n");
                                        outGC.write("\t <port type=\"output\" name=\"1\"/>\n");
                                        outGC.write("</sw_channel>\n\n");

                                        outGC.write("<sw_channel type=\"fifo\" size=\""+fifoSize+"\" name=\"FIFO_"+j+"_"+i+"_CON\">\n");
                                        outGC.write("\t<port type=\"input\" name=\"0\"/>\n");
                                        outGC.write("\t <port type=\"output\" name=\"1\"/>\n");
                                        outGC.write("</sw_channel>\n\n");
                                }
                        }
		}
		catch (IOException e) {}
	}

	public static void fifoGen(BufferedWriter outf, String fn)
	{
		try 
		{
			outf.write("<sw_channel type=\"fifo\" size=\""+fifoSize+"\" name=\""+fn+"\">\n");
			outf.write("\t<port type=\"input\" name=\"0\"/>\n");
			outf.write("\t<port type=\"output\" name=\"1\"/>\n");
			outf.write("</sw_channel>\n");
		}
		catch (IOException e) {}

	}
	public static void XMLInit(BufferedWriter outx)
	{
		try {
			outx.write("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n");
			outx.write("<processnetwork xmlns=\"http://www.tik.ee.ethz.ch/~shapes/schema/PROCESSNETWORK\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://www.tik.ee.ethz.ch/~shapes/schema/PROCESSNETWORK http://www.tik.ee.ethz.ch/~shapes/schema/processnetwork.xsd\" name=\"model"+model_num+"\">\n\n");
			outx.write("<variable value=\""+N+"\" name=\"N\"/>\n");
			}
		catch (IOException e) {}	
	}
 

	public static String processNameGen(int i, int j)
	{
		String pn = new String();
		pn = "p" + "_" + i + "_" + j;
		return pn;
	}

	public static String portNameGen(int i, int j, int type)
	{
		String pn = new String();
		if(type == 0)
			pn = "OUT" + "x" + i + "x" + j;
		else
			pn = "IN" + "x" + i + "x" + j;
		return pn;
	}
	public static String fifoNameGen(int i, int j, int k, int l)
	{
		String fn = new String();
		fn = "FIFO"+"_"+ i +"_"+ j +"_"+ k +"_"+ l;
		return fn;
	}
	public static String connectionNameGen(int i, int j, int k, int l, int type)
	{
		String cn = new String();
		if(type == 0)
			cn = "p-f"+"_"+i+"_"+j+"_"+k+"_"+l;
		else
			cn = "f-p"+"_"+i+"_"+j+"_"+k+"_"+l;
		return cn;
	}
	public static void Send(String matrix, int x, BufferedWriter outC, BufferedWriter outH)
	{
		try
		{
			String port = "OUT" + x;
			outC.write("\nDOL_write((void*)"+port+", p->local->"+matrix+");");
			outH.write("\n#define "+port+" "+x);
		}
		catch (IOException e) {}
	}
	public static void Initiate(int k, BufferedWriter outC, BufferedWriter outH)
	{
		try
		{
			outC.write("\nNow in a function\n");
		}
		catch(IOException e) {}
	}													
} 

