#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "generator.h"

// initialization function
void generator_init(DOLProcess *p) 
{
	p->local->index = 0;
	p->local->len = LENGTH;

	srand(time(NULL));
	p->local->seed = rand()%10;  //random seed
}

int generator_fire(DOLProcess *p) 
{
	int i, j, k, l;
	double sum;
	CREATEPORTVAR(prt);
	
	if (p->local->index < p->local->len) 
	{
		/*Initialize the Matrix-Lower Triangle with Random elements*/	
		for(i = 0; i < DIM; i++)
		{
			for(j = 0; j < DIM; j++)
			{
				srand(p->local->seed);
				if(j > i)
					p->local->a[i][j] = 0;
				else
					p->local->a[i][j] = (double)(rand()%10 + 1);
				p->local->seed++;
			}
		}

		//Print the INPUT Matrix
		printf("Generator: Lower Triangular Input:\n");
		for(i = 0; i < DIM; i++)
		{
			for(j = 0; j < DIM; j++)
			{
				printf("%.2f ",p->local->a[i][j]);
			}
			printf("\n");
		}
		printf("\n");
		printf("\n");
	
		//Multiply
		for(i = 0; i < DIM; i++)
		{
			for(j = 0; j < DIM; j++) 
			{
				sum = 0.0;
				for(k = 0; k < DIM; k++)
					sum += p->local->a[i][k] * p->local->a[j][k];
				p->local->C[i][j] = sum;
	    		}
		}
		printf("Generator Multiply:\n");
		for(i = 0; i < DIM; i++)
		{
			for(j = 0; j < DIM; j++)
			{
				printf("%.2f ",p->local->C[i][j]);
			}
			printf("\n");
		}
		printf("\n");
		printf("\n");
	
	
		/*Send the matrix*/
		for(i = 0; i < NCUT; i++)
		{
			for(j = i; j < NCUT; j++)
			{
				for(k = 0; k < N; k++)
				{
					for(l = 0; l < N; l++)
					{		
						p->local->temp[k][l] = p->local->C[k + j*N][l + i*N];
					}
				}
				CREATEPORT(prt, PORT_OUT, 2, j, NCUT, i, NCUT);
				
				DOL_write((void*)prt, p->local->temp, N*N*sizeof(double), p);
			}
		}
		
		p->local->index++;
	}
	/*Detach*/
	if (p->local->index >= p->local->len) 
	{
		DOL_detach(p);
		return -1;
	}
	return 0;
}

